Subject: Re: Bittorrent (Was: RE: [HACKERS] [SUGGESTION] CVSync )

From: "Magnus Hagander" <[email-masked]>
Date: Mon, 27 Mar 2006 21:48:45 +0200

> > It's automatically reproduced every 10 minutes. There are two
> > possibilities:
> 
> 'k, I'm seeing processes running since 2pm Sunday ... so 
> "every 10 minutes", what exactly is happening?
> 
> # ps aux | grep btlaunchmany | grep Sun02 | wc -l
>        36

Yeah. That's a reasonably normal amount of timing.
What happens is that the script detects a lot of btlaunchmany that are
suddenly gone. Either they are still there, and not showing up, or they
are dead. It could well be that they've crashed.

BTW, I've disabled the cronjob now since it sends an email to the slaves
list every 10 minutes :-) So right now, nothing happens.

> > 2) They are no longer reported in a way that Proc::ProcessTable can 
> > read. See the code at 
> > 
> http://gborg.postgresql.org/cgi-bin/cvsweb.cgi/portal/tools/bt/updatet
> > or rents.pl?rev=1.8;cvsroot=pgweb for what we're trying to do. It is
> > *possible* this is done because the processes are swapped 
> out, though 
> > I
> > *think* I tested the code and it handled that.
> 
> 'k, first ... "processes are swapped out" ... unless 
> something really odd is happening, I've never heard of a 
> process swapped out that is removed from the process table 
> ... at least not under FreeBSD ...

Nope, that would be really weird. But it could well be a bug in the perl
library Proc::ProcessTable as well.

> second ... have you manually verified that the process(es) 
> *aren't* running, or just relying on that script?  As i 
> stated above, I see 36 processes running for the past 24 hrs 
> +, and a bunch for a shorter period ...

I did that. But it's a bit hard to catch it at the right moment. I
*think* I've seen both.

> > Tar up /usr/local/www/bt.postgresql.org.
> > There are no "bittorrent binaries", they are all python 
> scripts. And 
> > they live under taht directory along with all our utility scripts.
> 
> Ah, okay ... I thought that we were using bittorrent as was 
> installed ages ago, not a self-maintained version ... but, if 
> that is the case, then I'm going to get rid of the template 
> stuff over there sometime this week, since that will be 
> simple enough to do ... python 2.4.2 is auto-installed, so no 
> problems there ...

Ok. good.

> If you can be online tomorrow afternoon ... ?  that way, when 
> I bring it back up, you are able to look over it for any issues ...

Afternoon your time or mine ;-)
I'll be online most of the day CET (~GMT), and I can also be online in
the evening if you need it.

> But, it doesn't look like bittorrent is reaping child processes:
> 
> # ps aux | grep "(python)" | wc -l
>       166
> 
> out of:
> 
> # ps aux | grep python | wc -l
>       201

Oh. Could *that* be where the problem comes from? Ithought the ()
indicated they were swapped out, I thin kit does on linux :-)

> > Where are you looking? That's before I started doing the web stuff, 
> > and I'm definitly the one who put in what's tyhere now.
> 
> /usr/local/bin ...

Oh :-) Didn't even know it was there.

//Magnus

---

From: "Marc G. Fournier" <[email-masked]>
Date: Mon, 27 Mar 2006 16:17:05 -0400 (AST)

> library Proc::ProcessTable as well.

Or, it could be not listing 'non-reaped (ie. Zombie)' processes ... but, 
the ps listing doesn't seem to be marking them as Zombie ...

> Afternoon your time or mine ;-)

I *think* we are 4 hours off ... always makes it fun to scheduale, I don't 
want to make it too late for you, but not too early for me :)

How about 6pm-ish your time, which I htink is around 2pm mine?

> indicated they were swapped out, I thin kit does on linux :-)

It could be ... only place I've ever noticed this is on a system where the 
child processes weren't being properly killed off though ...

----
Marc G. Fournier           Hub.Org Networking Services (http://www.hub.org)
Email: [email-masked]           Yahoo!: yscrappy              ICQ: 7615664